function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys, key, i;
    if (typeof Reflect !== "undefined" && Reflect.ownKeys) {
        sourceKeys = Reflect.ownKeys(source);
        for(i = 0; i < sourceKeys.length; i++){
            key = sourceKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
        return target;
    }
    target = _object_without_properties_loose(source, excluded);
    if (Object.getOwnPropertySymbols) {
        sourceKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceKeys.length; i++){
            key = sourceKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {}, sourceKeys = Object.getOwnPropertyNames(source), key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _to_array(arr) {
    return _array_with_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
import React, { forwardRef, memo, useRef } from "react";
import { cx } from "../../../../utils";
import { useForkRef } from "../../../../hooks";
import { classes } from "../../Calendar.tokens";
import { StyledItem, StyledItemRoot, StyledEvent, StyledEvents } from "./DateStructureItem.styles";
/**
 * Компонент элемента даты в сетке календаря.
 */ export var DateStructureItem = /*#__PURE__*/ memo(/*#__PURE__*/ forwardRef(function(_0, _1) {
    var _ref = [
        _0,
        _1
    ], _ref1 = _to_array(_ref), _ref2 = _ref1[0], _rest = _ref1.slice(1), children = _ref2.children, isFocused = _ref2.isFocused, dayOfWeek = _ref2.dayOfWeek, disabled = _ref2.disabled, isCurrent = _ref2.isCurrent, isSelected = _ref2.isSelected, isDayInCurrentMonth = _ref2.isDayInCurrentMonth, isDouble = _ref2.isDouble, inRange = _ref2.inRange, isHovered = _ref2.isHovered, sideInRange = _ref2.sideInRange, _ref_eventList = _ref2.eventList, eventList = _ref_eventList === void 0 ? [] : _ref_eventList, day = _ref2.day, monthIndex = _ref2.monthIndex, year = _ref2.year, onClick = _ref2.onClick, onMouseOver = _ref2.onMouseOver, onTriggerEventTooltip = _ref2.onTriggerEventTooltip, onFocus = _ref2.onFocus, disabledArrowKey = _ref2.disabledArrowKey, disabledMonths = _ref2.disabledMonths, rest = _object_without_properties(_ref2, [
        "children",
        "isFocused",
        "dayOfWeek",
        "disabled",
        "isCurrent",
        "isSelected",
        "isDayInCurrentMonth",
        "isDouble",
        "inRange",
        "isHovered",
        "sideInRange",
        "eventList",
        "day",
        "monthIndex",
        "year",
        "onClick",
        "onMouseOver",
        "onTriggerEventTooltip",
        "onFocus",
        "disabledArrowKey",
        "disabledMonths"
    ]), _rest1 = _sliced_to_array(_rest, 1), outerRef = _rest1[0];
    var structureRef = useRef(null);
    var innerRef = useForkRef(outerRef, structureRef);
    var selectableClass = !dayOfWeek && !disabled ? classes.selectableItem : undefined;
    var selectedClass = isDayInCurrentMonth && isSelected ? classes.selectedItem : undefined;
    var currentClass = isDayInCurrentMonth && isCurrent ? classes.currentItem : undefined;
    var hoveredClass = isDayInCurrentMonth && isHovered ? classes.hoveredItem : undefined;
    var dayOfWeekClass = dayOfWeek ? classes.dayOfWeek : undefined;
    var dayInCurrentMonthClass = isDayInCurrentMonth ? classes.dayInCurrentMonth : undefined;
    var disabledClass = disabled && !isCurrent ? classes.disabled : undefined;
    var disabledCurrentClass = disabled && isCurrent ? classes.disabledCurrent : undefined;
    var sideInRangeLeft = isDayInCurrentMonth && sideInRange === 'left' ? classes.sideLeft : undefined;
    var sideInRangeRight = isDayInCurrentMonth && sideInRange === 'right' ? classes.sideRight : undefined;
    var sideInRangeClass = isDayInCurrentMonth && sideInRange ? classes.sideInRange : undefined;
    var inRangeStyle = isDayInCurrentMonth && inRange ? classes.inRange : undefined;
    var sideOffset = !isSelected && isCurrent ? -1 : 0;
    var handleMouseOver = function handleMouseOver(event) {
        if (onMouseOver) {
            onMouseOver(event);
        }
        if (onTriggerEventTooltip) {
            var eventNodes = (eventList === null || eventList === void 0 ? void 0 : eventList.map(function(param) {
                var eventInfo = param.eventInfo;
                return eventInfo;
            }).filter(Boolean)) || [];
            onTriggerEventTooltip(structureRef, eventNodes);
        }
    };
    return /*#__PURE__*/ React.createElement(StyledItemRoot, _object_spread({
        ref: innerRef,
        className: cx(disabledClass, disabledCurrentClass, dayOfWeekClass, selectableClass, selectedClass, currentClass, hoveredClass, dayInCurrentMonthClass),
        tabIndex: isFocused ? 0 : -1,
        dayOfWeek: dayOfWeek,
        isCurrent: isCurrent,
        isSelected: isSelected,
        isDayInCurrentMonth: isDayInCurrentMonth,
        isDouble: isDouble,
        isHovered: isHovered,
        sideInRange: sideInRange,
        onClick: disabled ? undefined : onClick,
        onMouseOver: handleMouseOver,
        onFocus: onFocus,
        "data-day": day,
        "data-month-index": monthIndex,
        "data-year": year,
        "data-disabled-arrow-key": disabledArrowKey || undefined,
        "data-disabled-months": disabledMonths || undefined,
        "aria-selected": isSelected,
        "aria-disabled": disabled,
        "aria-describedby": disabled ? 'withShift' : undefined
    }, rest), /*#__PURE__*/ React.createElement(StyledItem, {
        className: cx(sideInRangeClass, sideInRangeLeft, sideInRangeRight, inRangeStyle),
        offset: sideOffset
    }, children), /*#__PURE__*/ React.createElement(StyledEvents, {
        "aria-hidden": true
    }, [
        eventList[0],
        eventList[1],
        eventList[2]
    ].map(function(event, i) {
        return event && /*#__PURE__*/ React.createElement(StyledEvent, {
            key: "".concat(event.date, "-").concat(i),
            color: event.color
        });
    })));
}));
